## pillow 9.0.1

=== Makefile ===
.DEFAULT_GOAL := help

.PHONY: clean
clean:
	python3 setup.py clean
	rm src/PIL/*.so || true
	rm -r build || true
	find . -name __pycache__ | xargs rm -r || true

.PHONY: coverage
coverage:
	pytest -qq
	rm -r htmlcov || true
	coverage report

.PHONY: doc
doc:
	$(MAKE) -C docs html

.PHONY: doccheck
doccheck:
	$(MAKE) -C docs html
# Don't make our tests rely on the links in the docs being up every single build.
# We don't control them.  But do check, and update them to the target of their redirects.
	$(MAKE) -C docs linkcheck || true

.PHONY: docserve
docserve:
	cd docs/_build/html && python3 -m http.server 2> /dev/null&

.PHONY: help
help:
	@echo "Welcome to Pillow development. Please use \`make <target>\` where <target> is one of"
	@echo "  clean              remove build products"
	@echo "  coverage           run coverage test (in progress)"
	@echo "  doc                make html docs"
	@echo "  docserve           run an http server on the docs directory"
	@echo "  html               to make standalone HTML files"
	@echo "  inplace            make inplace extension"
	@echo "  install            make and install"
	@echo "  install-coverage   make and install with C coverage"
	@echo "  install-req        install documentation and test dependencies"
	@echo "  install-venv       (deprecated) install in virtualenv"
	@echo "  lint               run the lint checks"
	@echo "  lint-fix           run black and isort to (mostly) fix lint issues."
	@echo "  release-test       run code and package tests before release"
	@echo "  test               run tests on installed pillow"
	@echo "  upload             build and upload sdists to PyPI"
	@echo "  upload-test        build and upload sdists to test.pythonpackages.com"

.PHONY: inplace
inplace: clean
	python3 -m pip install -e --global-option="build_ext" --global-option="--inplace" .

.PHONY: install
install:
	python3 -m pip install .
	python3 selftest.py

.PHONY: install-coverage
install-coverage:
	CFLAGS="-coverage -Werror=implicit-function-declaration" python3 -m pip install --global-option="build_ext" .
	python3 selftest.py

.PHONY: debug
debug:
# make a debug version if we don't have a -dbg python. Leaves in symbols
# for our stuff, kills optimization, and redirects to dev null so we
# see any build failures.
	make clean > /dev/null
	CFLAGS='-g -O0' python3 -m pip install --global-option="build_ext" . > /dev/null

.PHONY: install-req
install-req:
	python3 -m pip install -r requirements.txt

.PHONY: install-venv
install-venv:
	echo "'install-venv' is deprecated and will be removed in a future Pillow release"
	virtualenv .
	bin/pip install -r requirements.txt

.PHONY: release-test
release-test:
	$(MAKE) install-req
	python3 -m pip install -e .
	python3 selftest.py
	python3 -m pytest Tests
	python3 -m pip install .
	-rm dist/*.egg
	-rmdir dist
	python3 -m pytest -qq
	check-manifest
	pyroma .
	$(MAKE) readme

.PHONY: sdist
sdist:
	python3 -m build --help > /dev/null 2>&1 || python3 -m pip install build
	python3 -m build --sdist

.PHONY: test
test:
	pytest -qq

.PHONY: valgrind
valgrind:
	python3 -c "import pytest_valgrind" || pip3 install pytest-valgrind
	PYTHONMALLOC=malloc valgrind --suppressions=Tests/oss-fuzz/python.supp --leak-check=no \
            --log-file=/tmp/valgrind-output \
            python3 -m pytest --no-memcheck -vv --valgrind --valgrind-log=/tmp/valgrind-output

.PHONY: readme
readme:
	python3 setup.py --long-description | markdown2 > .long-description.html && open .long-description.html


.PHONY: lint
lint:
	tox --help > /dev/null || python3 -m pip install tox
	tox -e lint

.PHONY: lint-fix
lint-fix:
	black --target-version py37 .
	isort .

=== requirements.txt ===
# Development, documentation & testing requirements.
black
check-manifest
coverage
defusedxml
markdown2
olefile
packaging
pyroma
pytest
pytest-cov
pytest-timeout
sphinx>=2.4
sphinx-copybutton
sphinx-issues>=3.0.1
sphinx-removed-in
sphinx-rtd-theme>=1.0
sphinxext-opengraph

=== debian/changelog ===
pillow (9.0.1-1) unstable; urgency=medium

  * New upstream version.
  * Fix documentation build error with Python 3.10 (Heinrich Schuchardt).

 -- Matthias Klose <doko@debian.org>  Fri, 18 Feb 2022 01:07:13 +0100

pillow (9.0.0-1) unstable; urgency=medium

  * New upstream version.

 -- Matthias Klose <doko@debian.org>  Mon, 10 Jan 2022 10:52:08 +0100

pillow (8.4.0-1) unstable; urgency=medium

  * New upstream version.

 -- Matthias Klose <doko@debian.org>  Thu, 25 Nov 2021 13:17:45 +0100

=== debian/control ===
Source: pillow
Section: python
Priority: optional
Maintainer: Matthias Klose <doko@debian.org>
Build-Depends: debhelper (>= 11), tk-dev, dpkg-dev (>= 1.16.1~),
  dh-python,
  python3-all-dev, python3-setuptools,
  python3-tk,
  python3-pytest,
  python3-olefile,
  python3-cffi,
  libfreetype6-dev, libjpeg-dev, zlib1g-dev, liblcms2-dev,
  libtiff5-dev | libtiff-dev, libwebp-dev, libraqm-dev,
  libimagequant-dev,
  libopenjp2-7-dev,
Build-Depends-Indep: python3-sphinx, python3-sphinx-rtd-theme,
  python3-sphinx-issues, python3-sphinx-copybutton,
Standards-Version: 4.6.0
Homepage: http://python-pillow.github.io/
XS-Testsuite: autopkgtest

Package: python3-pil
Architecture: any
Multi-Arch: same
Depends: ${python3:Depends}, mime-support | python3-pil.imagetk,
  ${shlibs:Depends}, ${misc:Depends}
Recommends: python3-olefile
Suggests: python-pil-doc
Provides: ${python:Provides}, python3-pillow
Conflicts: python3-imaging (<< 1.1.7+2.0.0-1.1)
Breaks: python3-imaging (<< 1.1.7+2.0.0-1.1)
Replaces: python3-imaging (<< 1.1.7+2.0.0-1.1)
Description: Python Imaging Library (Python3)
 The Python Imaging Library (PIL) adds an image object to your Python
 interpreter. You can load images from a variety of file formats, and
 apply a rich set of image operations to them.
 .
 Image Objects:
  o Bilevel, greyscale, palette, true colour (RGB), true colour with
    transparency (RGBA).
  o colour separation (CMYK).
  o Copy, cut, paste operations.
  o Flip, transpose, resize, rotate, and arbitrary affine transforms.
  o Transparency operations.
  o Channel and point operations.
  o Colour transforms, including matrix operations.
  o Image enhancement, including convolution filters.
 .
 File Formats:
  o Full (Open/Load/Save): BMP, EPS (with ghostscript), GIF, IM, JPEG,
    MSP, PDF, PNG, PPM, TIFF, XBM.
  o Read only (Open/Load): ARG, CUR, DCX, FLI, FPX, GBR, GD, ICO, IMT, IPTC,
    MCIDAS, MPEG, PhotoCD, PCX, PIXAR, PSD, TGA, SGI, SUN, TGA, WMF, XPM.
  o Save only: PDF, EPS (without ghostscript).

Package: python3-pil.imagetk
Architecture: any
Multi-Arch: same
Depends: python3-pil (= ${binary:Version}),
  python3-tk (>= 3.4.1-2),
  ${python3:Depends}, ${shlibs:Depends}, ${misc:Depends}
Suggests: python-pil-doc
Provides: ${python:Provides}
Breaks: python3-imaging-tk (<< 1.1.7+2.0.0-1.1)
Replaces: python3-imaging-tk (<< 1.1.7+2.0.0-1.1)
Description: Python Imaging Library - ImageTk Module (Python3)
 Tk dependent python-pil module.

Package: python-pil-doc
Section: doc
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}, ${sphinxdoc:Depends}
Suggests: python3-doc, python3-pil, python3-pil.imagetk
Description: Examples for the Python Imaging Library
 The Python Imaging Library (PIL) adds an image object to your
 Python interpreter. You can load image objects from a variety of file
 formats, and apply a rich set of image operations to them.
 .
 This package contains PIL API documentation and some example scripts.
 You may also want to look at the python-pil-doc-html or
 python-pil-doc-pdf packages for the PIL handbook documentation.

=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

PY3VERS	:= $(shell py3versions -vr)
PY3VER	:= $(shell python3 -c 'import re, sys;print(re.match("^\d*\.\d*", sys.version).group())')

include /usr/share/python3/python.mk

include /usr/share/dpkg/architecture.mk
ifneq ($(DEB_BUILD_MULTIARCH),$(DEB_HOST_MULTIARCH))
  SET_CROSS_ENV = PYTHONPATH=/usr/lib/python$$pv/plat-$(DEB_HOST_MULTIARCH)

  # FIXME: is this sufficient?
  SET_CROSS_ENV += _PYTHON_HOST_PLATFORM=$(DEB_HOST_GNU_CPU)
endif

build-arch: BBB=bbb
build-indep: III=iii
build-arch: build
build-indep: build build-doc-stamp
build: build-stamp

build-doc-stamp: build
	echo XXXXXXXXXXXX BBB=$(BBB) / III=$(III)
	-PYTHONPATH=$(CURDIR)/$(wildcard build/lib.*-$(PY3VER)) $(MAKE) -C docs html
	touch $@

build-stamp: $(PY3VERS:%=build-stamp-python%) $(PY3VERS:%=check-stamp-python%)
	touch $@
build-stamp-python%:
	echo XXXXXXXXXXXX BBB=$(BBB) / III=$(III)
#	tar xvf debian/lcms-images.tar.gz
	$(SET_CROSS_ENV) python$* setup.py build
	touch $@

pillow_tests = $(wildcard Tests/test*.py)

check-stamp-python%:
ifeq (0,1)
ifeq ($(DEB_BUILD_MULTIARCH),$(DEB_HOST_MULTIARCH))
	rm -rf tmp
	mkdir -p tmp
	ln -s ../Tests tmp/Tests
	ln -s ../build tmp/build
	@echo BEGIN python$* tests
	-cd tmp && python$* ../debian/test-built.py --processes=1 --process-timeout=90 $(pillow_tests)
endif
endif
	touch $@

clean:
	dh_testdir
	dh_testroot
	rm -f *-stamp*
	rm -rf compile build
	rm -rf debian/PILcompat/build
	rm -rf Pillow*.egg-info
	find -name '*.py[co]' -exec rm -f {} \;
	find -type d -name __pycache__ | xargs -r rm -rf
#	rm -f $$(tar tf debian/lcms-images.tar.gz)
	rm -rf tmp
	rm -rf docs/_build
	dh_clean

get-doc:
	wget -r --no-parent --no-host-directories --cut-dirs=2 \
		http://www.pythonware.com/library/pil/handbook/index.htm

install: build install-prereq $(PY3VERS:%=install3-python%)
	dh_installdocs -ppython-pil-doc #Docs/*
	dh_installexamples -ppython-pil-doc

	dh_installdocs -ppython3-pil README.md

	: # Replace all '#!' calls to python with /usr/bin/python
	: # and make them executable
	for i in `find debian/python3-pil* -mindepth 3 -type f`; do \
	  sed '1s,#!.*python[^ ]*\(.*\),#! /usr/bin/python3\1,' \
		$$i > $$i.temp; \
	  if cmp --quiet $$i $$i.temp; then \
	    rm -f $$i.temp; \
	  else \
	    mv -f $$i.temp $$i; \
	    chmod 755 $$i; \
	    echo "fixed interpreter: $$i"; \
	  fi; \
	done

install-prereq:
	dh_testdir
	dh_testroot
	dh_prep

install3-python%:
	$(SET_CROSS_ENV) python$* setup.py install \
		--root $(CURDIR)/debian/python3-pil \
		$(py_setup_install_args)

	incdir=$$(python$* -c 'import sysconfig; print(sysconfig.get_path("include"))'); \
	mkdir -p debian/python3-pil/$$incdir; \
	install -o root -g root -m 644 \
		src/libImaging/Imaging.h \
		src/libImaging/ImagingUtils.h \
		src/libImaging/ImPlatform.h \
		src/libImaging/ImDib.h \
		debian/python3-pil/$$incdir

	if `python$* -c "import sys; sys.exit(sys.version_info < (3,5))"`; \
	then \
		abitag=.$$(python$* -c "import sysconfig; print(sysconfig.get_config_var('SOABI'))"); \
	else \
		abitag=.$$(python$* -c "import sysconfig; print(sysconfig.get_config_var('SOABI'))")-$(DEB_HOST_MULTIARCH); \
	fi; \
	echo $$abitag; \
	dh_movefiles -ppython3-pil.imagetk \
	    --sourcedir=debian/python3-pil \
		usr/lib/python3/$(call py_sitename_sh, $*)/PIL/_imagingtk$$abitag.so \
		usr/lib/python3/$(call py_sitename_sh, $*)/PIL/ImageTk.py

# Build architecture-independent files here.
# Pass -i to all debhelper commands in this target to reduce clutter.
binary-indep: build build-doc-stamp install
	echo XXXXXXXXXXXX BBB=$(BBB) / III=$(III)
	dh_testdir -i
	dh_testroot -i
	dh_installdocs -i
	dh_installdocs -ppython-pil-doc docs/_build/html
	dh_sphinxdoc -ppython-pil-doc
	dh_installexamples -i
	dh_installchangelogs -i CHANGES.rst
	dh_python3 -i
	dh_link -i
	dh_compress -i -X.py
	dh_fixperms -i
	dh_installdeb -i
	dh_gencontrol -i
	dh_md5sums -i
	dh_builddeb -i

# Build architecture-dependent files here.
binary-arch: build install
	echo XXXXXXXXXXXX BBB=$(BBB) / III=$(III)
	dh_testdir -a
	dh_testroot -a
	dh_installdocs -a
	dh_installexamples -a
	dh_installchangelogs -a CHANGES.rst
	dh_python3 -a
	dh_strip -a
	dh_link -a
	dh_compress -a -X.py
	dh_fixperms -a
	dh_installdeb -a
	dh_shlibdeps -a
	dh_gencontrol -a
	dh_md5sums -a
	dh_builddeb -a

binary: binary-indep binary-arch
.PHONY: build clean binary-indep binary-arch binary install

## pillow 9.2.0

=== debian/changelog ===
pillow (9.2.0-1) unstable; urgency=medium

  * New upstream version.

 -- Matthias Klose <doko@debian.org>  Sun, 17 Jul 2022 13:57:17 +0200

pillow (9.1.1-1) unstable; urgency=medium

  * New upstream version.
    - CVE-2022-30595: When reading past the end of a TGA scan line,
      reduce bytes left.
    - Do not open images with zero or negative height (#6269).

 -- Matthias Klose <doko@debian.org>  Fri, 27 May 2022 11:56:13 +0200

pillow (9.1.0-1) unstable; urgency=medium

  * New upstream version.

 -- Matthias Klose <doko@debian.org>  Mon, 04 Apr 2022 13:08:08 +0200

=== debian/rules ===
--- 
+++ 
@@ -16,21 +16,19 @@
   SET_CROSS_ENV += _PYTHON_HOST_PLATFORM=$(DEB_HOST_GNU_CPU)
 endif
 
-build-arch: BBB=bbb
-build-indep: III=iii
+build-arch:
+build-indep:
 build-arch: build
 build-indep: build build-doc-stamp
 build: build-stamp
 
 build-doc-stamp: build
-	echo XXXXXXXXXXXX BBB=$(BBB) / III=$(III)
 	-PYTHONPATH=$(CURDIR)/$(wildcard build/lib.*-$(PY3VER)) $(MAKE) -C docs html
 	touch $@
 
 build-stamp: $(PY3VERS:%=build-stamp-python%) $(PY3VERS:%=check-stamp-python%)
 	touch $@
 build-stamp-python%:
-	echo XXXXXXXXXXXX BBB=$(BBB) / III=$(III)
 #	tar xvf debian/lcms-images.tar.gz
 	$(SET_CROSS_ENV) python$* setup.py build
 	touch $@
@@ -122,7 +120,6 @@
 # Build architecture-independent files here.
 # Pass -i to all debhelper commands in this target to reduce clutter.
 binary-indep: build build-doc-stamp install
-	echo XXXXXXXXXXXX BBB=$(BBB) / III=$(III)
 	dh_testdir -i
 	dh_testroot -i
 	dh_installdocs -i
@@ -141,7 +138,6 @@
 
 # Build architecture-dependent files here.
 binary-arch: build install
-	echo XXXXXXXXXXXX BBB=$(BBB) / III=$(III)
 	dh_testdir -a
 	dh_testroot -a
 	dh_installdocs -a

## pillow 9.4.0

=== Makefile ===
.DEFAULT_GOAL := help

.PHONY: clean
clean:
	python3 setup.py clean
	rm src/PIL/*.so || true
	rm -r build || true
	find . -name __pycache__ | xargs rm -r || true

.PHONY: coverage
coverage:
	python3 -c "import pytest" > /dev/null 2>&1 || python3 -m pip install pytest
	python3 -m pytest -qq
	rm -r htmlcov || true
	python3 -c "import coverage" > /dev/null 2>&1 || python3 -m pip install coverage
	python3 -m coverage report

.PHONY: doc
doc:
	python3 -c "import PIL" > /dev/null 2>&1 || python3 -m pip install .
	$(MAKE) -C docs html

.PHONY: doccheck
doccheck:
	$(MAKE) doc
# Don't make our tests rely on the links in the docs being up every single build.
# We don't control them.  But do check, and update them to the target of their redirects.
	$(MAKE) -C docs linkcheck || true

.PHONY: docserve
docserve:
	cd docs/_build/html && python3 -m http.server 2> /dev/null&

.PHONY: help
help:
	@echo "Welcome to Pillow development. Please use \`make <target>\` where <target> is one of"
	@echo "  clean              remove build products"
	@echo "  coverage           run coverage test (in progress)"
	@echo "  doc                make HTML docs"
	@echo "  docserve           run an HTTP server on the docs directory"
	@echo "  html               to make standalone HTML files"
	@echo "  inplace            make inplace extension"
	@echo "  install            make and install"
	@echo "  install-coverage   make and install with C coverage"
	@echo "  lint               run the lint checks"
	@echo "  lint-fix           run Black and isort to (mostly) fix lint issues"
	@echo "  release-test       run code and package tests before release"
	@echo "  test               run tests on installed Pillow"

.PHONY: inplace
inplace: clean
	python3 -m pip install -e --global-option="build_ext" --global-option="--inplace" .

.PHONY: install
install:
	python3 -m pip -v install .
	python3 selftest.py

.PHONY: install-coverage
install-coverage:
	CFLAGS="-coverage -Werror=implicit-function-declaration" python3 -m pip -v install --global-option="build_ext" .
	python3 selftest.py

.PHONY: debug
debug:
# make a debug version if we don't have a -dbg python. Leaves in symbols
# for our stuff, kills optimization, and redirects to dev null so we
# see any build failures.
	make clean > /dev/null
	CFLAGS='-g -O0' python3 -m pip -v install --global-option="build_ext" . > /dev/null

.PHONY: release-test
release-test:
	python3 -m pip install -e .[tests]
	python3 selftest.py
	python3 -m pytest Tests
	python3 -m pip install .
	-rm dist/*.egg
	-rmdir dist
	python3 -m pytest -qq
	python3 -m check_manifest
	python3 -m pyroma .
	$(MAKE) readme

.PHONY: sdist
sdist:
	python3 -m build --help > /dev/null 2>&1 || python3 -m pip install build
	python3 -m build --sdist
	python3 -m twine --help > /dev/null 2>&1 || python3 -m pip install twine
	python3 -m twine check --strict dist/*

.PHONY: test
test:
	python3 -c "import pytest" > /dev/null 2>&1 || python3 -m pip install pytest
	python3 -m pytest -qq

.PHONY: valgrind
valgrind:
	python3 -c "import pytest_valgrind" > /dev/null 2>&1 || python3 -m pip install pytest-valgrind
	PYTHONMALLOC=malloc valgrind --suppressions=Tests/oss-fuzz/python.supp --leak-check=no \
            --log-file=/tmp/valgrind-output \
            python3 -m pytest --no-memcheck -vv --valgrind --valgrind-log=/tmp/valgrind-output

.PHONY: readme
readme:
	python3 -c "import markdown2" > /dev/null 2>&1 || python3 -m pip install markdown2
	python3 -m markdown2 README.md > .long-description.html && open .long-description.html


.PHONY: lint
lint:
	python3 -c "import tox" > /dev/null 2>&1 || python3 -m pip install tox
	python3 -m tox -e lint

.PHONY: lint-fix
lint-fix:
	python3 -c "import black" > /dev/null 2>&1 || python3 -m pip install black
	python3 -c "import isort" > /dev/null 2>&1 || python3 -m pip install isort
	python3 -m black --target-version py37 .
	python3 -m isort .

=== debian/changelog ===
pillow (9.4.0-1.1+deb12u1) bookworm-security; urgency=high

  * Non-maintainer upload by the Security Team.
  * Backport fixes for CVE-2023-44271, CVE-2023-50447, CVE-2024-28219.

 -- Sean Whitton <spwhitton@spwhitton.name>  Sun, 02 Jun 2024 09:57:25 +0100

pillow (9.4.0-1.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Handle more than one directory returned by pkg-config (Closes: #1028904).

 -- Bastian Germann <bage@debian.org>  Mon, 16 Jan 2023 16:29:25 +0100

pillow (9.4.0-1) unstable; urgency=medium

  * New upstream version.

 -- Matthias Klose <doko@debian.org>  Tue, 03 Jan 2023 10:06:46 +0100

pillow (9.3.0-1) unstable; urgency=medium

  * New upstream version.
  * Bump standards version.

 -- Matthias Klose <doko@debian.org>  Mon, 26 Dec 2022 12:37:12 +0100

pillow (9.2.0-1.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Add patch to fix FTBFS (Closes: #1020043)

 -- Nilesh Patra <nilesh@debian.org>  Fri, 21 Oct 2022 15:53:14 +0000

=== debian/control ===
--- 
+++ 
@@ -15,7 +15,8 @@
   libopenjp2-7-dev,
 Build-Depends-Indep: python3-sphinx, python3-sphinx-rtd-theme,
   python3-sphinx-issues, python3-sphinx-copybutton,
-Standards-Version: 4.6.0
+  python3-sphinx-inline-tabs,
+Standards-Version: 4.6.1
 Homepage: http://python-pillow.github.io/
 XS-Testsuite: autopkgtest

## pillow 10.0.0

=== debian/changelog ===
pillow (10.0.0-1ubuntu0.2) mantic-security; urgency=medium

  * SECURITY UPDATE: Buffer overflow in imagingcms.c
    - debian/patches/CVE-2024-28219.patch: Use strncpy
    to avoid buffer overflow
    - CVE-2024-28219

 -- Nick Galanis <nick.galanis@canonical.com>  Mon, 15 Apr 2024 14:52:02 +0100

pillow (10.0.0-1ubuntu0.1) mantic-security; urgency=medium

  * SECURITY UPDATE: PIL.ImageMath.eval Arbitrary Code Execution
    - debian/patches/CVE-2023-50447-1.patch: don't allow __ or builtins in
      env dictionarys for ImageMath.eval in src/PIL/ImageMath.py.
    - debian/patches/CVE-2023-50447-2.patch: allow ops in
      Tests/test_imagemath.py, src/PIL/ImageMath.py.
    - debian/patches/CVE-2023-50447-3.patch: include further builtins in
      Tests/test_imagemath.py, src/PIL/ImageMath.py.
    - CVE-2023-50447

 -- Marc Deslauriers <marc.deslauriers@ubuntu.com>  Thu, 25 Jan 2024 10:02:07 -0500

pillow (10.0.0-1) unstable; urgency=medium

  * New upstream version.

 -- Matthias Klose <doko@debian.org>  Wed, 05 Jul 2023 18:58:54 +0200

pillow (9.5.0-1) unstable; urgency=medium

  * New upstream version.
  * Bump standards version.
  * debian/patches/pkg-config-multiarch.diff: Remove, applied upstream.

 -- Matthias Klose <doko@debian.org>  Mon, 12 Jun 2023 09:30:20 +0200

=== debian/control ===
--- 
+++ 
@@ -1,7 +1,8 @@
 Source: pillow
 Section: python
 Priority: optional
-Maintainer: Matthias Klose <doko@debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Matthias Klose <doko@debian.org>
 Build-Depends: debhelper (>= 11), tk-dev, dpkg-dev (>= 1.16.1~),
   dh-python,
   python3-all-dev, python3-setuptools,
@@ -16,7 +17,7 @@
 Build-Depends-Indep: python3-sphinx, python3-sphinx-rtd-theme,
   python3-sphinx-issues, python3-sphinx-copybutton,
   python3-sphinx-inline-tabs,
-Standards-Version: 4.6.1
+Standards-Version: 4.6.2
 Homepage: http://python-pillow.github.io/
 XS-Testsuite: autopkgtest

## pillow 10.1.0

=== debian/changelog ===
pillow (10.1.0-1) unstable; urgency=medium

  * New upstream version.
  * Depend on media-types instead of mime-support. Closes: #987500.

 -- Matthias Klose <doko@debian.org>  Tue, 31 Oct 2023 13:24:15 +0100

## pillow 10.2.0

=== Makefile ===
--- 
+++ 
@@ -16,9 +16,15 @@
 	python3 -m coverage report
 
 .PHONY: doc
-doc:
+.PHONY: html
+doc html:
 	python3 -c "import PIL" > /dev/null 2>&1 || python3 -m pip install .
 	$(MAKE) -C docs html
+
+.PHONY: htmlview
+htmlview:
+	python3 -c "import PIL" > /dev/null 2>&1 || python3 -m pip install .
+	$(MAKE) -C docs htmlview
 
 .PHONY: doccheck
 doccheck:
@@ -38,18 +44,14 @@
 	@echo "  coverage           run coverage test (in progress)"
 	@echo "  doc                make HTML docs"
 	@echo "  docserve           run an HTTP server on the docs directory"
-	@echo "  html               to make standalone HTML files"
-	@echo "  inplace            make inplace extension"
+	@echo "  html               make HTML docs"
+	@echo "  htmlview           open the index page built by the html target in your browser"
 	@echo "  install            make and install"
 	@echo "  install-coverage   make and install with C coverage"
 	@echo "  lint               run the lint checks"
-	@echo "  lint-fix           run Black and isort to (mostly) fix lint issues"
+	@echo "  lint-fix           run Ruff to (mostly) fix lint issues"
 	@echo "  release-test       run code and package tests before release"
 	@echo "  test               run tests on installed Pillow"
-
-.PHONY: inplace
-inplace: clean
-	python3 -m pip install -e --global-option="build_ext" --global-option="--inplace" .
 
 .PHONY: install
 install:
@@ -58,7 +60,7 @@
 
 .PHONY: install-coverage
 install-coverage:
-	CFLAGS="-coverage -Werror=implicit-function-declaration" python3 -m pip -v install --global-option="build_ext" .
+	CFLAGS="-coverage -Werror=implicit-function-declaration" python3 -m pip -v install .
 	python3 selftest.py
 
 .PHONY: debug
@@ -67,10 +69,11 @@
 # for our stuff, kills optimization, and redirects to dev null so we
 # see any build failures.
 	make clean > /dev/null
-	CFLAGS='-g -O0' python3 -m pip -v install --global-option="build_ext" . > /dev/null
+	CFLAGS='-g -O0' python3 -m pip -v install . > /dev/null
 
 .PHONY: release-test
 release-test:
+	python3 Tests/check_release_notes.py
 	python3 -m pip install -e .[tests]
 	python3 selftest.py
 	python3 -m pytest Tests
@@ -115,6 +118,6 @@
 .PHONY: lint-fix
 lint-fix:
 	python3 -c "import black" > /dev/null 2>&1 || python3 -m pip install black
-	python3 -c "import isort" > /dev/null 2>&1 || python3 -m pip install isort
-	python3 -m black --target-version py37 .
-	python3 -m isort .
+	python3 -m black .
+	python3 -c "import ruff" > /dev/null 2>&1 || python3 -m pip install ruff
+	python3 -m ruff --fix .

=== debian/changelog ===
pillow (10.2.0-1build1) noble; urgency=high

  * No change rebuild for 64-bit time_t and frame pointers.

 -- Julian Andres Klode <juliank@ubuntu.com>  Mon, 08 Apr 2024 18:15:35 +0200

pillow (10.2.0-1) unstable; urgency=medium

  * New upstream version. Addresses CVE-2023-50447. Closes: #1061172.

 -- Matthias Klose <doko@debian.org>  Sat, 20 Jan 2024 10:47:10 +0100

=== debian/control ===
--- 
+++ 
@@ -24,7 +24,7 @@
 Package: python3-pil
 Architecture: any
 Multi-Arch: same
-Depends: ${python3:Depends}, mime-support | python3-pil.imagetk,
+Depends: ${python3:Depends}, media-types | python3-pil.imagetk,
   ${shlibs:Depends}, ${misc:Depends}
 Recommends: python3-olefile
 Suggests: python-pil-doc

=== debian/rules ===
--- 
+++ 
@@ -23,7 +23,7 @@
 build: build-stamp
 
 build-doc-stamp: build
-	-PYTHONPATH=$(CURDIR)/$(wildcard build/lib.*-$(PY3VER)) $(MAKE) -C docs html
+	-PYTHONPATH=$(CURDIR)/$(firstword $(wildcard build/lib.*)) $(MAKE) -C docs html
 	touch $@
 
 build-stamp: $(PY3VERS:%=build-stamp-python%) $(PY3VERS:%=check-stamp-python%)

## pillow 10.3.0

=== debian/changelog ===
pillow (10.3.0-2) unstable; urgency=medium

  * Allow stderr in autopkg tests, deprecation warning for Pillow 12.

 -- Matthias Klose <doko@debian.org>  Wed, 03 Apr 2024 09:03:08 +0200

pillow (10.3.0-1) unstable; urgency=medium

  * New upstream version.
  * Update watch file.

 -- Matthias Klose <doko@debian.org>  Tue, 02 Apr 2024 17:53:35 +0200

=== debian/control ===
--- 
+++ 
@@ -1,8 +1,7 @@
 Source: pillow
 Section: python
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Matthias Klose <doko@debian.org>
+Maintainer: Matthias Klose <doko@debian.org>
 Build-Depends: debhelper (>= 11), tk-dev, dpkg-dev (>= 1.16.1~),
   dh-python,
   python3-all-dev, python3-setuptools,

## pillow 10.4.0

=== debian/changelog ===
pillow (10.4.0-1ubuntu2) plucky; urgency=medium

  * No-change rebuild with Python 3.13 as supported version

 -- Graham Inggs <ginggs@ubuntu.com>  Thu, 14 Nov 2024 01:29:58 +0000

pillow (10.4.0-1ubuntu1) oracular; urgency=medium

  * debian/rules: Set DPKG_EXPORT_BUILDFLAGS = 1 and include
    /usr/share/dpkg/buildflags.mk to pick up the correct compiler flags
    (LP: #2077744)

 -- Graham Inggs <ginggs@ubuntu.com>  Fri, 23 Aug 2024 16:35:57 +0000

pillow (10.4.0-1) unstable; urgency=medium

  * New upstream version.

 -- Matthias Klose <doko@debian.org>  Wed, 10 Jul 2024 09:55:27 +0200

## pillow 11.1.0

=== Makefile ===
--- 
+++ 
@@ -2,7 +2,6 @@
 
 .PHONY: clean
 clean:
-	python3 setup.py clean
 	rm src/PIL/*.so || true
 	rm -r build || true
 	find . -name __pycache__ | xargs rm -r || true
@@ -18,12 +17,10 @@
 .PHONY: doc
 .PHONY: html
 doc html:
-	python3 -c "import PIL" > /dev/null 2>&1 || python3 -m pip install .
 	$(MAKE) -C docs html
 
 .PHONY: htmlview
 htmlview:
-	python3 -c "import PIL" > /dev/null 2>&1 || python3 -m pip install .
 	$(MAKE) -C docs htmlview
 
 .PHONY: doccheck
@@ -78,8 +75,6 @@
 	python3 selftest.py
 	python3 -m pytest Tests
 	python3 -m pip install .
-	-rm dist/*.egg
-	-rmdir dist
 	python3 -m pytest -qq
 	python3 -m check_manifest
 	python3 -m pyroma .
@@ -120,4 +115,9 @@
 	python3 -c "import black" > /dev/null 2>&1 || python3 -m pip install black
 	python3 -m black .
 	python3 -c "import ruff" > /dev/null 2>&1 || python3 -m pip install ruff
-	python3 -m ruff --fix .
+	python3 -m ruff check --fix .
+
+.PHONY: mypy
+mypy:
+	python3 -c "import tox" > /dev/null 2>&1 || python3 -m pip install tox
+	python3 -m tox -e mypy

=== debian/changelog ===
pillow (11.1.0-5) unstable; urgency=medium

  * Don't remove the pyproject.toml file.

 -- Matthias Klose <doko@debian.org>  Thu, 06 Feb 2025 14:26:25 +0100

pillow (11.1.0-4) unstable; urgency=medium

  * Install Python files for arch-only builds. Closes: #1093826.

 -- Matthias Klose <doko@debian.org>  Thu, 23 Jan 2025 11:32:24 +0100

pillow (11.1.0-3) unstable; urgency=medium

  * Fix indep-only build.

 -- Matthias Klose <doko@debian.org>  Thu, 23 Jan 2025 05:34:00 +0100

pillow (11.1.0-1) unstable; urgency=medium

  * New upstream version.
  * Build the docs, ignoring the warnings. Closes: #1091974.
  * Bump standards version.

 -- Matthias Klose <doko@debian.org>  Wed, 22 Jan 2025 13:58:23 +0100

pillow (10.4.0-1.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Set `Rules-Requires-Root: binary-targets`.
    (Closes: #1089414)

 -- Niels Thykier <niels@thykier.net>  Thu, 02 Jan 2025 20:42:06 +0000

=== debian/control ===
--- 
+++ 
@@ -13,10 +13,13 @@
   libtiff5-dev | libtiff-dev, libwebp-dev, libraqm-dev,
   libimagequant-dev,
   libopenjp2-7-dev,
-Build-Depends-Indep: python3-sphinx, python3-sphinx-rtd-theme,
+Build-Depends-Indep: python3-doc,
+  python3-sphinx, python3-sphinx-rtd-theme,
   python3-sphinx-issues, python3-sphinx-copybutton,
-  python3-sphinx-inline-tabs,
-Standards-Version: 4.6.2
+  python3-sphinx-inline-tabs, python3-sphinxext-opengraph,
+  furo,
+Rules-Requires-Root: binary-targets
+Standards-Version: 4.7.0
 Homepage: http://python-pillow.github.io/
 XS-Testsuite: autopkgtest

## pillow 11.2.1

=== debian/changelog ===
pillow (11.2.1-1) experimental; urgency=medium

  * New upstream version.
  * Build-depend on libavif-dev.
  * Still build the docs using sphinx 8.1.x.
  * Bump standards version.

 -- Matthias Klose <doko@debian.org>  Wed, 23 Apr 2025 08:05:57 +0200

## pillow 11.3.0

=== debian/changelog ===
pillow (11.3.0-1ubuntu2) resolute; urgency=medium

  * No-change rebuild with Python 3.14 as supported version

 -- Graham Inggs <ginggs@ubuntu.com>  Sat, 18 Oct 2025 21:56:00 +0000

pillow (11.3.0-1ubuntu1) questing; urgency=medium

  * Drop build dependency on libavif-dev, not in main.

 -- Matthias Klose <doko@ubuntu.com>  Tue, 02 Sep 2025 07:59:45 +0200

pillow (11.3.0-1) unstable; urgency=medium

  * New upstream version.

 -- Matthias Klose <doko@debian.org>  Thu, 28 Aug 2025 12:15:42 +0200

=== debian/control ===
--- 
+++ 
@@ -9,6 +9,7 @@
   python3-pytest,
   python3-olefile,
   python3-cffi,
+#  libavif-dev,
   libfreetype6-dev, libjpeg-dev, zlib1g-dev, liblcms2-dev,
   libtiff5-dev | libtiff-dev, libwebp-dev, libraqm-dev,
   libimagequant-dev,

=== debian/watch ===
version=3
http://pypi.debian.net/pillow/pillow-(.*)\.(?:tar\.gz|zip)

## pillow 12.0.0

=== Makefile ===
--- 
+++ 
@@ -23,6 +23,10 @@
 htmlview:
 	$(MAKE) -C docs htmlview
 
+.PHONY: htmllive
+htmllive:
+	$(MAKE) -C docs htmllive
+
 .PHONY: doccheck
 doccheck:
 	$(MAKE) doc
@@ -43,6 +47,7 @@
 	@echo "  docserve           run an HTTP server on the docs directory"
 	@echo "  html               make HTML docs"
 	@echo "  htmlview           open the index page built by the html target in your browser"
+	@echo "  htmllive           rebuild and reload HTML files in your browser"
 	@echo "  install            make and install"
 	@echo "  install-coverage   make and install with C coverage"
 	@echo "  lint               run the lint checks"
@@ -70,7 +75,7 @@
 
 .PHONY: release-test
 release-test:
-	python3 Tests/check_release_notes.py
+	python3 checks/check_release_notes.py
 	python3 -m pip install -e .[tests]
 	python3 selftest.py
 	python3 -m pytest Tests
@@ -92,12 +97,26 @@
 	python3 -c "import pytest" > /dev/null 2>&1 || python3 -m pip install pytest
 	python3 -m pytest -qq
 
+.PHONY: test-p
+test-p:
+	python3 -c "import xdist" > /dev/null 2>&1 || python3 -m pip install pytest-xdist
+	python3 -m pytest -qq -n auto
+
+
 .PHONY: valgrind
 valgrind:
 	python3 -c "import pytest_valgrind" > /dev/null 2>&1 || python3 -m pip install pytest-valgrind
-	PYTHONMALLOC=malloc valgrind --suppressions=Tests/oss-fuzz/python.supp --leak-check=no \
+	PILLOW_VALGRIND_TEST=true PYTHONMALLOC=malloc valgrind --suppressions=Tests/oss-fuzz/python.supp --leak-check=no \
             --log-file=/tmp/valgrind-output \
             python3 -m pytest --no-memcheck -vv --valgrind --valgrind-log=/tmp/valgrind-output
+
+.PHONY: valgrind-leak
+valgrind-leak:
+	python3 -c "import pytest_valgrind" > /dev/null 2>&1 || python3 -m pip install pytest-valgrind
+	PILLOW_VALGRIND_TEST=true PYTHONMALLOC=malloc valgrind --suppressions=Tests/oss-fuzz/python.supp \
+	    --leak-check=full --show-leak-kinds=definite --errors-for-leak-kinds=definite \
+            --log-file=/tmp/valgrind-output \
+            python3 -m pytest -vv --valgrind --valgrind-log=/tmp/valgrind-output
 
 .PHONY: readme
 readme:

=== docs/Makefile ===
# Makefile for Sphinx documentation
#

# You can set these variables from the command line.
PYTHON        = python3
SPHINXBUILD   = $(PYTHON) -m sphinx.cmd.build
SPHINXOPTS    = --fail-on-warning
BUILDDIR      = _build
BUILDER       = html
JOBS          = auto
PAPER         =

# Internal variables.
PAPEROPT_a4     = --define latex_paper_size=a4
PAPEROPT_letter = --define latex_paper_size=letter

ALLSPHINXOPTS   = --builder $(BUILDER) \
                  --doctree-dir $(BUILDDIR)/doctrees \
                  --jobs $(JOBS) \
                  $(PAPEROPT_$(PAPER)) \
                  $(SPHINXOPTS) \
                  . $(BUILDDIR)/$(BUILDER)

.PHONY: help
help:
	@echo "Please use \`make <target>' where <target> is one of"
	@echo "  html       to make standalone HTML files"
	@echo "  htmlview   to open the index page built by the html target in your browser"
	@echo "  htmllive   to rebuild and reload HTML files in your browser"
	@echo "  serve      to start a local server for viewing docs"
	@echo "  dirhtml    to make HTML files named index.html in directories"
	@echo "  singlehtml to make a single large HTML file"
	@echo "  linkcheck  to check all external links for integrity"

.PHONY: clean
clean:
	-rm -rf $(BUILDDIR)/*

install-sphinx:
	$(PYTHON) -m pip install -e ..[docs]

.PHONY: html
html:
	$(MAKE) install-sphinx
	$(SPHINXBUILD) $(ALLSPHINXOPTS)

.PHONY: dirhtml
dirhtml: BUILDER = dirhtml
dirhtml: html

.PHONY: singlehtml
singlehtml: BUILDER = singlehtml
singlehtml: html

.PHONY: linkcheck
linkcheck: BUILDER = linkcheck
linkcheck: html

.PHONY: htmlview
htmlview: html
	$(PYTHON) -c "import os, webbrowser; webbrowser.open('file://' + os.path.realpath('$(BUILDDIR)/html/index.html'))"

.PHONY: htmllive
htmllive: SPHINXBUILD = $(PYTHON) -m sphinx_autobuild
htmllive: SPHINXOPTS = --open-browser --delay 0
htmllive: html

.PHONY: serve
serve:
	cd $(BUILDDIR)/html; $(PYTHON) -m http.server

=== debian/changelog ===
pillow (12.0.0-1) unstable; urgency=medium

  * New upstream version.

 -- Matthias Klose <doko@debian.org>  Wed, 22 Oct 2025 14:52:17 +0200

=== debian/control ===
--- 
+++ 
@@ -9,7 +9,8 @@
   python3-pytest,
   python3-olefile,
   python3-cffi,
-#  libavif-dev,
+  python3-pybind11,
+  libavif-dev,
   libfreetype6-dev, libjpeg-dev, zlib1g-dev, liblcms2-dev,
   libtiff5-dev | libtiff-dev, libwebp-dev, libraqm-dev,
   libimagequant-dev,

=== debian/rules ===
--- 
+++ 
@@ -2,10 +2,12 @@
 
 # Uncomment this to turn on verbose mode.
 #export DH_VERBOSE=1
+DPKG_EXPORT_BUILDFLAGS = 1
 
 PY3VERS	:= $(shell py3versions -vr)
-PY3VER	:= $(shell python3 -c 'import re, sys;print(re.match("^\d*\.\d*", sys.version).group())')
+PY3VER	:= $(shell py3versions -vd)
 
+include /usr/share/dpkg/buildflags.mk
 include /usr/share/python3/python.mk
 
 include /usr/share/dpkg/architecture.mk
@@ -23,7 +25,10 @@
 build: build-stamp
 
 build-doc-stamp: build
-	-PYTHONPATH=$(CURDIR)/$(firstword $(wildcard build/lib.*)) $(MAKE) -C docs html
+	: # FIXME: do not ignore warnings ...
+#	-PYTHONPATH=$(CURDIR)/src:$(CURDIR)/$(lastword $(wildcard build/lib.*)) $(MAKE) -C docs html
+	(cd src; tar cf - PIL) | (cd $(lastword $(wildcard build/lib.*)); tar xf -)
+	-PYTHONPATH=$(CURDIR)/$(lastword $(wildcard build/lib.*)) $(MAKE) -C docs html
 	touch $@
 
 build-stamp: $(PY3VERS:%=build-stamp-python%) $(PY3VERS:%=check-stamp-python%)
@@ -105,6 +110,11 @@
 		src/libImaging/ImDib.h \
 		debian/python3-pil/$$incdir
 
+	: # FIXME: not installed anymore upstream?
+	mkdir -p debian/python3-pil/usr/lib/python3/$(call py_sitename_sh, $*)/PIL
+	(cd src; tar cf - PIL) \
+	  | (cd debian/python3-pil/usr/lib/python3/$(call py_sitename_sh, $*); tar xf -)
+
 	if `python$* -c "import sys; sys.exit(sys.version_info < (3,5))"`; \
 	then \
 		abitag=.$$(python$* -c "import sysconfig; print(sysconfig.get_config_var('SOABI'))"); \

=== debian/tests/control ===
Tests: selftest-py3
Restrictions: allow-stderr
Depends: @

#Tests: upstream-py3
#Restrictions: allow-stderr
#Depends: @, webp, python3-pytest

## pillow 12.1.0

=== debian/changelog ===
pillow (12.1.0-1) unstable; urgency=medium

  * New upstream version.
  * Bump standards version.

 -- Matthias Klose <doko@debian.org>  Mon, 19 Jan 2026 11:18:50 +0100

## pillow 12.1.1

=== debian/changelog ===
pillow (12.1.1-1ubuntu1) resolute; urgency=medium

  * Merge with Debian; remaining changes:
    - Don't build with libavif support (universe). No decision yet
      if it will be included in main. See LP 2130005.

 -- Matthias Klose <doko@ubuntu.com>  Mon, 16 Feb 2026 10:59:47 +0100

pillow (12.1.1-1) unstable; urgency=medium

  * New upstream version.

 -- Matthias Klose <doko@debian.org>  Mon, 16 Feb 2026 10:55:44 +0100

pillow (12.0.0-1ubuntu1) resolute; urgency=medium

  * debian/control:
    - restore delta to drop the use of libavif since it is still in
      universe for Ubuntu

 -- Sebastien Bacher <seb128@ubuntu.com>  Tue, 28 Oct 2025 11:41:27 +0100

=== debian/control ===
--- 
+++ 
@@ -1,7 +1,8 @@
 Source: pillow
 Section: python
 Priority: optional
-Maintainer: Matthias Klose <doko@debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Matthias Klose <doko@debian.org>
 Build-Depends: debhelper (>= 11), tk-dev, dpkg-dev (>= 1.16.1~),
   dh-python,
   python3-all-dev, python3-setuptools,
@@ -10,7 +11,7 @@
   python3-olefile,
   python3-cffi,
   python3-pybind11,
-  libavif-dev,
+#  libavif-dev,
   libfreetype6-dev, libjpeg-dev, zlib1g-dev, liblcms2-dev,
   libtiff5-dev | libtiff-dev, libwebp-dev, libraqm-dev,
   libimagequant-dev,
@@ -21,7 +22,7 @@
   python3-sphinx-inline-tabs, python3-sphinxext-opengraph,
   furo,
 Rules-Requires-Root: binary-targets
-Standards-Version: 4.7.0
+Standards-Version: 4.7.3
 Homepage: http://python-pillow.github.io/
 XS-Testsuite: autopkgtest

## pillow jpls-1.3.1

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.24)
cmake_policy(SET CMP0148 NEW)

project(Pycharls VERSION 1.3.1)

find_package(Python COMPONENTS Interpreter Development.Module)
find_package(pybind11 CONFIG REQUIRED)
find_package(charls CONFIG REQUIRED)
find_package(fmt CONFIG REQUIRED)
find_package(Eigen3 CONFIG REQUIRED)

if (MSVC)
    add_compile_options(/Wall /permissive-)
else()
    add_compile_options(-Wall -Wextra -Wpedantic -Wno-unknown-pragmas)
    if (CMAKE_CXX_COMPILER_ID MATCHES Clang$)
        add_compile_options(-Wconversion -Wconditional-uninitialized)
    endif()
endif()

add_subdirectory(src)

=== src/CMakeLists.txt ===
Python_add_library(_pycharls MODULE pycharls.cpp WITH_SOABI)

set_target_properties(_pycharls PROPERTIES
        INTERPROCEDURAL_OPTIMIZATION ON
        CXX_VISIBILITY_PRESET hidden
        VISIBILITY_INLINES_HIDDEN ON)

target_compile_features(_pycharls PRIVATE cxx_std_17)
target_compile_definitions(_pycharls PRIVATE VERSION_INFO=${PROJECT_VERSION})

if (MSVC)
    #various warnings introuced by external code
    target_compile_options(_pycharls PRIVATE /wd4191 /wd4686 /wd5045 /wd4710 /wd4711 /wd4868)
    # unknown pragmas used by GCC
    target_compile_options(_pycharls PRIVATE /wd4068)
endif()

target_link_libraries( _pycharls
    PRIVATE
        pybind11::headers
        charls
        Eigen3::Eigen
        fmt::fmt
        )

install(TARGETS _pycharls
        LIBRARY DESTINATION pillow_jpls
        )
